%define name xrmap
%define version 2.33
%define release %mkrel 1

Summary: A tool to manipulate and create Earth maps
Summary(fr): Un outil pour manipuler et gnrer des cartes de la Terre.
Name: %{name}
Version: %{version}
Release: %{release}
License: GPL
Group: Sciences/Geosciences
Source: ftp://ftp.ac-grenoble.fr/ge/geosciences/xrmap/%{name}-%{version}.tar.bz2
URL: http://freshmeat.net/projects/xrmap/
BuildRoot: %{_tmppath}/%{name}-buildroot

Buildrequires:	X11-devel
BuildRequires:	X11

%description
The Xrmap program is a user-friendly X client for generating maps of the 
Earth. It is based on the CIA World data bank II, a set of vector data
produced in the early eighties. The maps can be very accurately zoomed in,
up to a factor of 100 or more.  The whole Earth can be explored by just
pointing and clicking, and the maps can be printed and (somewhat) edited at
any scale.

Xrmap is derived from the original command line program
'rmap' by Reza Naima (http://www.reza.net/rmap/).
However, Xrmap has many more features than 'rmap', especially it implements 
8 different projections (Spherical, Rectangular, Cylindrical, Mercator, 
Miller, Sinusoidal, Elliptic, Mollweide). It includes data bases for cities,
mountains, airports, observatories, and also extensive information on world 
countries and other data (flags, hymns, anthems, local maps, ...).

%prep
rm -rf $RPM_BUILD_ROOT

%setup -q

%build
xmkmf
%make CDEBUGFLAGS="$RPM_OPT_FLAGS" CXXDEBUGFLAGS="$RPM_OPT_FLAGS"

# %install
make install DESTDIR=$RPM_BUILD_ROOT%{_prefix}
make install.man DESTDIR=$RPM_BUILD_ROOT%{_prefix}
if [ -f $RPM_BUILD_ROOT%{_prefix}/X11R6/man/man1/xrmap.1x ]; then
find $RPM_BUILD_ROOT%{_prefix}/X11R6/man/man1/xrmap.1x -type f -exec bzip2 -9f {} \;
fi

if [ -f $RPM_BUILD_ROOT/usr/usr/X11R6/lib/X11/doc/html/xrmap.1.html ]; then
mkdir -p $RPM_BUILD_ROOT%{_prefix}/X11R6/lib/X11/doc/html/
mv $RPM_BUILD_ROOT%{_prefix}/usr/X11R6/lib/X11/doc/html/xrmap.1.html $RPM_BUILD_ROOT%{_prefix}/X11R6/lib/X11/doc/html/xrmap.1.html
rm -rf $RPM_BUILD_ROOT%{_prefix}/usr/
fi

mkdir -p $RPM_BUILD_ROOT%_datadir/icons
install xrmap.xpm -m 644 $RPM_BUILD_ROOT%_datadir/icons/xrmap.xpm
install editkit/emx $RPM_BUILD_ROOT%{_prefix}/X11R6/bin

#mkdir -p $RPM_BUILD_ROOT%_datadir/rmap/{anthems,examples,extra}
#install anthems/* -m 644 $RPM_BUILD_ROOT%_datadir/rmap/anthems
#install examples/* -m 644 $RPM_BUILD_ROOT%_datadir/rmap/examples
#install extra/* -m 644 $RPM_BUILD_ROOT%_datadir/rmap/extra

#mkdir -p $RPM_BUILD_ROOT%_datadir/rmap/factbook/{extra,text}
#install factbook/extra/* -m 644 $RPM_BUILD_ROOT%_datadir/rmap/factbook/extra
#install factbook/text/* -m 644 $RPM_BUILD_ROOT%_datadir/rmap/factbook/text

#mkdir -p $RPM_BUILD_ROOT%_datadir/rmap/flags/{big,small}
#install flags/big/* -m 644 $RPM_BUILD_ROOT%_datadir/rmap/flags/big
#install flags/small/* -m 644 $RPM_BUILD_ROOT%_datadir/rmap/flags/small

#mkdir -p $RPM_BUILD_ROOT/usr/share/rmap/hymns
#install hymns/* -m 644 $RPM_BUILD_ROOT/usr/share/rmap/hymns

mkdir -p $RPM_BUILD_ROOT/usr/share/rmap/tools/{anthems,cbd2else,factbook,jpd2else,locutils,rez2else,upgrade}
install tools/anthems/* -m 644 $RPM_BUILD_ROOT%_datadir/rmap/tools/anthems
install tools/cbd2else/* -m 644 $RPM_BUILD_ROOT%_datadir/rmap/tools/cbd2else
install tools/factbook/* -m 644 $RPM_BUILD_ROOT%_datadir/rmap/tools/factbook
install tools/jpd2else/* -m 644 $RPM_BUILD_ROOT%_datadir/rmap/tools/jpd2else
install tools/locutils/* -m 644 $RPM_BUILD_ROOT%_datadir/rmap/tools/locutils
install tools/rez2else/* -m 644 $RPM_BUILD_ROOT%_datadir/rmap/tools/rez2else
install tools/upgrade/* -m 644 $RPM_BUILD_ROOT%_datadir/rmap/tools/upgrade

install -d $RPM_BUILD_ROOT%{_menudir}
cat <<EOF > $RPM_BUILD_ROOT%{_menudir}/%{name}
?package(%{name}): \
        needs="X11" \
        section="More Applications/Sciences/Geosciences" \
        title="Xrmap" \
        longtitle="Manipulate and create images of Earth" \
        command="%{name}" \
        icon="toys_section.png"
EOF

%post
%update_menus

%postun
%clean_menus

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,0755)
%doc CHANGES INSTALL LICENSE MAPEDIT README TODO VECTORMAP midi_cfg/* tools/README.tools rc/00_example.rc 
%{_datadir}/icons/xrmap.xpm
%{_datadir}/rmap
%{_datadir}/editkit
%{_prefix}/X11R6/bin/earthview
%{_prefix}/X11R6/bin/emx
%{_prefix}/X11R6/bin/xrmap
%{_prefix}/X11R6/man/man1/xrmap.1*
%{_prefix}/X11R6/man/man1/emx.1*
%{_prefix}/X11R6/lib/X11/doc/html/xrmap.1.html
%{_prefix}/X11R6/lib/X11/doc/html/emx.1.html
%_menudir/*

%changelog
* Sun Nov 6 2005
- new version 2.33 by upstream

* Wed Sep 15 2005 Franck Villaume <fvill@mandriva.org> 2.32-1mdk
- new version 2.32
- fix source url

* Thu Aug 25 2005 Franck Villaume <fvill@mandriva.org> 2.31-1mdk
- new version 2.31

* Sat Apr 23 2005 Franck Villaume <fvill@mandriva.org> 2.30-2mdk
- buildrequires again

* Mon Apr 18 2005 Franck Villaume <fvill@mandriva.org> 2.30-1mdk
- new release
- buildrequires

* Thu Sep 23 2004 Lenny Cartier <lenny@mandrakesoft.com> 2.29-1mdk
- new

* Fri Apr 05 2002 Francois Massonneau <frmas@free.fr>
- Added post uninstalled settings

* Tue Aug 14 2001 Francois Massonneau <frmas@free.fr>
- First spec file
